
/*  HTTaP_client.js
  created ven. mai  8 01:58:23 CEST 2020 by whygee@f-cpu.org

Manages the single-socket connection to a HTTaP server.

 */


HTTaP={
////////////////// Deferred, serialised loading of images //////////////////
// (useful for Chrome...)

  deferred_array:[],

  Deferred_image_load_callback: function() {
    var i=HTTaP.deferred_array.shift();
    if (i) {
      if (typeof i=="function") {
        HTTaP.deferred_array=[];
        i();
      }
      else {
        i.src = i.id;
        setTimeout(HTTaP.Deferred_image_load_callback, 50);
      }
    }
  },

  Deferred_image_load: function(base, callback) {
    base=base||document;
    var i, n, t=base.getElementsByTagName("img");
    HTTaP.deferred_array=[];

    // cleanup:
    for (i=0; i < t.length; i++) {
      n=t[i];
      if(   n.className
        && (n.className=="DeferLoad")
        &&  n.id)
          HTTaP.deferred_array.push(n);
    }

    HTTaP.deferred_array.push( callback  // if not provided,
       || function() {});         // push an empty function
    HTTaP.Deferred_image_load_callback();
  },

//////////////////////////////////////////////////////////////
  HlogoRed:    "data:image/gif;base64,R0lGODlhDQANAKECAAAAAP8A",  // They differ only by a couple
  HlogoGreen:  "data:image/gif;base64,R0lGODlhDQANAKECAAAAAAD/",  // of bytes in the palette
  HlogoSuffix: "AP///////yH5BAEKAAIALAAAAAANAA0AAAIjlB15K+m6njwJSBtQwA63ekkbQJYiByppB60pJULwxGjZUgAAOw==",
  margin: 3,     // Send keepalive packet 3s before timeout
  ready: 0,      // 1 when it can accept a new XHR transaction
  H_img:null,    // Image object
  session:"",    // string for the session id
  count:0,       // total number of pings
  timeout:-1,    // how many seconds between requests
  delay_id:null, // the currently running timer's id, so it can be aborted

  release:function() {
    HTTaP.ready=1;
    HTTaP.H_img.src=HTTaP.HlogoGreen+HTTaP.HlogoSuffix;
  },

  lock:function() {
    HTTaP.ready=0;
    HTTaP.H_img.src=HTTaP.HlogoRed+HTTaP.HlogoSuffix;
  },

/*  Keepalive_callback: function() {

  },
*/
  ping_init: function() {
    HTTaP.lock();
    var XHR=new XMLHttpRequest();
    XHR.timeout = HTTaP.margin*2*1000;
    XHR.responseType = 'json';
    XHR.onabort
   =XHR.onerror
   =XHR.ontimeout
   =HTTaP.ping_callback_KO;
    XHR.onload=HTTaP.ping_callback_OK;
    XHR.open("get", "/?ping_"+(HTTaP.count++), true);
    XHR.send();
  },

  ping_callback_OK: function() {
    if (this.readyState != 4)
      return;
    if ((this.status === 200)
     && (this.getResponseHeader("Content-Type") == "application/json")
     && (this.response) // != null : no parse error
     && (HTTaP.session ==this.getResponseHeader("HTTaP-Session"))
     && (typeof this.response.Timeout == "number")) {
      new_pre("Ping : "+this.response.Remain);
      HTTaP.release();
      HTTaP.timeout=this.response.Timeout;
      if (HTTaP.timeout <= HTTaP.margin)
          HTTaP.timeout  = HTTaP.margin+1;
      delay_id=setTimeout(HTTaP.ping_init,
          (HTTaP.timeout-HTTaP.margin)*1000);
    }
    else
      HTTaP.ping_callback_KO();
  },

  ping_callback_KO: function() {
    new_pre("Ping error ?");
  },


  init: function() {
    // create an absolute image on the top right corner
    var i=(HTTaP.H_img=document.createElement("img"));
    i.style.zindex=999;
    i.style.position="fixed";
    i.style.top="0px";
    i.style.right="0px";
    i.alt="HTTaP activity";
    document.body.appendChild(i);

    HTTaP.session="";
    HTTaP.count=0;
    HTTaP.delay_id=null;
    HTTaP.timeout=-1;

    // Get the root page to validate the protocol :
    var XHR=new XMLHttpRequest();
    XHR.responseType = "json";
    XHR.timeout = HTTaP.margin*2*1000;
    XHR.onabort=function () { new_pre("HTTaP init : abort");  HTTaP.lock(); };
    XHR.onerror=function () { new_pre("HTTaP init : error");  HTTaP.lock(); };
    XHR.ontimeout=function(){ new_pre("HTTaP init : timeout");HTTaP.lock(); };
    XHR.onload=function () {
      if (this.readyState != 4 )
        return;
      // Got the reply from root
      if ((this.status === 200)
       // Expect a number of properties from the reply
       && (this.getResponseHeader("Content-Type") == "application/json")
       && (this.response) // != null : no parse error
       && (typeof this.response.HTTaP_version == "string")
       && (this.response.HTTaP_version.length == 8)
       && (HTTaP.session
          =this.getResponseHeader("HTTaP-Session")) // != null: the session header exists
       && (HTTaP.session.length == 8) ) {
        new_pre("HTTaP session='"+HTTaP.session+"'  version="
            +this.response.HTTaP_version+" ID='"+this.response.ID+"'");
        return HTTaP.ping_init();  // Setup the XHR for periodinc pings
      }
      HTTaP.lock();
    };

    XHR.open("get", "/?", true);
    XHR.send();
  },

  init_finish: function() {
    setTimeout(HTTaP.release, 10);
  }
}
